@SETLOCAL
@Echo Off

@Set TE_BASE=%~dp0
@If "%TE_BASE:~-1%"=="\" Set TE_BASE=%TE_BASE:~0,-1%

@Set TE_OUT=%TE_BASE%\IMPORT_VLTX.OUT
@Set TE_TEE=%TE_BASE%\WTEE.EXE -a %TE_OUT%
@Rem @Set TE_TEE=%TE_BASE%\MTEE.EXE /+ %TE_OUT%

@Echo. | %TE_TEE%
@Echo. | %TE_TEE%
@Echo. ++++++++++++++++++++ >> %TE_OUT%
@Echo. IMPORT_VLTX Starting ... %DATE% at %TIME% | %TE_TEE%

@For %%A in (VLT VLT2 VLT3 VLT4 VLT5) Do @If "%1"=="%%A" Goto 200
@If NOT "%1"=="" Goto END

:200
@Set TableNameVLT=%1
@For %%A in (VLT VLT2 VLT3 VLT4 VLT5) Do @If "%TableNameVLT%"=="%%A" Goto 280
@Rem @Set TableNameVLT=VLT2
:280

@Set TE_PAUSE=%2

@Set TE_DBSVR=.\SQLEXPRESS
@Set TE_DBSVR=.\SYSTECH
@Set TE_DB=CAVIP_Systest
@Set TE_DB=Systest

@If Exist %TE_BASE%\GET_DB_INFO.CMD CALL %TE_BASE%\GET_DB_INFO.CMD

@Set TE_VLTSRC=%TE_BASE%\%TableNameVLT%.DAT
@If "%TableNameVLT%"=="VLT" @Set TE_VLTSRC=%TE_BASE%\%TableNameVLT%1.DAT
@Set TE_VLTVER=%TE_BASE%\%TableNameVLT%.VER
@If "%TableNameVLT%"=="VLT" @Set TE_VLTVER=%TE_BASE%\%TableNameVLT%1.VER
@Set TE_TBL=dbo.%TableNameVLT%
@Set TE_RECLIST=dbo.RecordList
@Set TE_RECLISTROW=%TableNameVLT%
@Set TE_RECLISTROW2=
@If "%TableNameVLT%"=="VLT" @Set TE_RECLISTROW2=%TableNameVLT%1
@Set TE_FMT=%TE_BASE%\VLT_FORMAT.XML
@Set TE_TMP=%TE_BASE%\IMPORT_%TableNameVLT%.TMP

@Set TE_RCDDATE=

@Echo. | %TE_TEE%
@Echo.  Current running base folder is "%TE_BASE% | %TE_TEE%
@Echo. | %TE_TEE%
@Echo.  This batch procedure will attempt to load the %TE_TBL% table | %TE_TEE%
@Echo.  (Base table name is %TableNameVLT%) | %TE_TEE%
@Echo.  in the "%TE_DB%" database | %TE_TEE%
@Echo   with "%TE_VLTSRC%" | %TE_TEE%
@Echo    and "%TE_VLTVER%" as the source | %TE_TEE%
@Echo.  using SQLCMD and "%TE_DBSVR%" | %TE_TEE%
@Echo.  as the database server. | %TE_TEE%
@Echo.  (%TE_OUT% will contain the output log.) | %TE_TEE%
@Echo. | %TE_TEE%
@Set TE1=%TE_FMT%
@If NOT Exist %TE1% Goto NO_FILE
@Set TE1=%TE_VLTSRC%
@If NOT Exist %TE1% Goto NO_FILE
@Set TE1=%TE_VLTVER%
@If NOT Exist %TE1% Goto NO_FILE
@Echo. | %TE_TEE%
@Echo.  Ready to start ... | %TE_TEE%
@If NOT "%TE_PAUSE%"=="" @Pause
@If "%TE_PAUSE%"=="" If Exist %TE_BASE%\SLEEP.EXE %TE_BASE%\SLEEP.EXE 3
@Echo.

@Echo. | %TE_TEE%
@Echo. %DATE% at %TIME% | %TE_TEE%
@Echo. | %TE_TEE%
@Echo.  Checking "version" information in %TE_VLTVER% ... | %TE_TEE%
@Set TE1=
@For /f "USEBACKQ DELIMS=" %%A in (%TE_VLTVER%) Do (Set TE1=%%A)
@Echo. Last row is "%TE1%" | %TE_TEE%
@If NOT "%TE1%"=="" Set TE1=%TE1:~8,14%
@Echo. VersionDate is "%TE1%" | %TE_TEE%
@If NOT "%TE1%"=="" Set TE_RCDDATE=%TE1:~0,4%-%TE1:~4,2%-%TE1:~6,2% %TE1:~8,2%:%TE1:~10,2%:%TE1:~12,2%
@Echo. RecordDate is "%TE_RCDDATE%" | %TE_TEE%
@If NOT "%TE_PAUSE%"=="" @Pause
@Echo. | %TE_TEE%


@Echo. | %TE_TEE%
@Echo.  Checking database connectivity via current row count ... | %TE_TEE%
@Set TE1=
@For /f "DELIMS=" %%A in ('SQLCMD -S %TE_DBSVR% -d %TE_DB% -w 120 -e -b -r1 -h-1 -Q "Set NOCOUNT ON; Select Count(*) as Row_Count from %TE_TBL%"') Do @Set TE1=%%A
@If ERRORLEVEL 1 Goto 1900
@If NOT "%TE1%"=="" @For /f %%A in ("%TE1%") Do @Set TE1=%%A
@Echo. | %TE_TEE%
@Echo.  Current row count is "%TE1% | %TE_TEE%
@If NOT "%TE1%"=="" If Exist %TE_BASE%\SLEEP.EXE %TE_BASE%\SLEEP.EXE 1
@If "%TE1%"=="" Goto 1900
@Goto 2000
:1900
@Echo. | %TE_TEE%
@Echo.  Error accessing "%TE_DB%" on "%TE_DBSVR%" ... No changes made. | %TE_TEE%
@If NOT "%TE_PAUSE%"=="" @Pause
@If "%TE_PAUSE%"=="" If Exist %TE_BASE%\SLEEP.EXE %TE_BASE%\SLEEP.EXE 10
@Goto END

:2000
@Echo. | %TE_TEE%
@Echo.  Checking current row count ... | %TE_TEE%
@Echo. SQLCMD -S %TE_DBSVR% -d %TE_DB% -w 120 -e -b -Q "Select Count(*) as Row_Count from %TE_TBL%" >>%TE_OUT%
       SQLCMD -S %TE_DBSVR% -d %TE_DB% -w 120 -e -b -Q "Select Count(*) as Row_Count from %TE_TBL%" | %TE_TEE%
@If ERRORLEVEL 1 Goto SQL_ERR
@Echo.
@If NOT "%TE_PAUSE%"=="" @Pause
@If "%TE_PAUSE%"=="" If Exist %TE_BASE%\SLEEP.EXE %TE_BASE%\SLEEP.EXE 1
@Echo. | %TE_TEE%


@Echo. | %TE_TEE%
@Echo.  Deleting all current rows in %TE_TBL% ... | %TE_TEE%
@If NOT "%TE_PAUSE%"=="" @Pause
@Echo. | %TE_TEE%
@Echo. SQLCMD -S %TE_DBSVR% -d %TE_DB% -w 120 -e -Q "Delete from %TE_TBL%" >> %TE_OUT%
       SQLCMD -S %TE_DBSVR% -d %TE_DB% -w 120 -e -Q "Delete from %TE_TBL%" | %TE_TEE%
@Echo. | %TE_TEE%
@If NOT "%TE_PAUSE%"=="" @Pause
@If "%TE_PAUSE%"=="" If Exist %TE_BASE%\SLEEP.EXE %TE_BASE%\SLEEP.EXE 1
@Echo. | %TE_TEE%


@Echo. | %TE_TEE%
@Echo.  Importing rows from %TE_VLTSRC% into %TE_TBL% | %TE_TEE%
@Echo BCP %TE_DB%.%TE_TBL% IN %TE_VLTSRC% -f %TE_FMT% -S %TE_DBSVR% -T -o %TE_TMP% | %TE_TEE%
      BCP %TE_DB%.%TE_TBL% IN %TE_VLTSRC% -f %TE_FMT% -S %TE_DBSVR% -T -o %TE_TMP% | %TE_TEE%
@Echo. | %TE_TEE%
@Rem @Echo. COPY %TE_OUT%+%TE_TMP% %TE_OUT%>>%TE_OUT%
@Rem COPY %TE_OUT%+%TE_TMP% %TE_OUT%
@Rem @Echo. | %TE_TEE%
@Rem @If NOT "%TE_PAUSE%"=="" NOTEPAD %TE_TMP% | %TE_TEE%
@Rem @If     "%TE_PAUSE%"=="" Type %TE_TMP% | %TE_TEE%
Type %TE_TMP% | %TE_TEE%
@Del %TE_TMP% | %TE_TEE%
@Echo. | %TE_TEE%
@If NOT "%TE_PAUSE%"=="" @Pause
@If "%TE_PAUSE%"=="" If Exist %TE_BASE%\SLEEP.EXE %TE_BASE%\SLEEP.EXE 1
@Echo. | %TE_TEE%


@Echo. | %TE_TEE%
@Echo.  Checking current row count ... | %TE_TEE%
@Echo. SQLCMD -S %TE_DBSVR% -d %TE_DB% -w 120 -e -Q "Select Count(*) as Row_Count from %TE_TBL%" >>%TE_OUT%
       SQLCMD -S %TE_DBSVR% -d %TE_DB% -w 120 -e -Q "Select Count(*) as Row_Count from %TE_TBL%" | %TE_TEE%
@Echo. | %TE_TEE%
@If NOT "%TE_PAUSE%"=="" @Pause
@If "%TE_PAUSE%"=="" If Exist %TE_BASE%\SLEEP.EXE %TE_BASE%\SLEEP.EXE 1
@Echo. | %TE_TEE%


@Echo. | %TE_TEE%
@Echo.  Strip any trailing blanks from som fields ... | %TE_TEE%

@For %%A in (ManCode Make Model EvapSysType NumEvapCan LocationCan AdviceCode DriveLayout) Do (
  @Echo. | %TE_TEE%
  @Echo. SQLCMD -S %TE_DBSVR% -d %TE_DB% -w 120 -e -Q "Update %TE_TBL% Set %%A = LTrim(RTrim(%%A))" >>%TE_OUT%
         SQLCMD -S %TE_DBSVR% -d %TE_DB% -w 120 -e -Q "Update %TE_TBL% Set %%A = LTrim(RTrim(%%A))" | %TE_TEE%
  @If Exist %TE_BASE%\SLEEP.EXE %TE_BASE%\SLEEP.EXE 1
)

@Rem @Echo. | %TE_TEE%
@Rem @Echo. SQLCMD -S %TE_DBSVR% -d %TE_DB% -w 120 -e -Q "Update %TE_TBL% Set Model = LTrim(RTrim(Model))" >>%TE_OUT%
@Rem        SQLCMD -S %TE_DBSVR% -d %TE_DB% -w 120 -e -Q "Update %TE_TBL% Set Model = LTrim(RTrim(Model))" | %TE_TEE%

@Echo. | %TE_TEE%
@If NOT "%TE_PAUSE%"=="" @Pause
@If "%TE_PAUSE%"=="" If Exist %TE_BASE%\SLEEP.EXE %TE_BASE%\SLEEP.EXE 1
@Echo. | %TE_TEE%


@Echo. | %TE_TEE%
@Echo.  Updating RecordDate in %TE_RECLIST% ... | %TE_TEE%
@Echo. SQLCMD -S %TE_DBSVR% -d %TE_DB% -w 120 -e -Q "UPDATE %TE_RECLIST% SET RecordDate = '%TE_RCDDATE%' WHERE TableName = '%TE_RECLISTROW%'" >>%TE_OUT%
       SQLCMD -S %TE_DBSVR% -d %TE_DB% -w 120 -e -Q "UPDATE %TE_RECLIST% SET RecordDate = '%TE_RCDDATE%' WHERE TableName = '%TE_RECLISTROW%'" | %TE_TEE%
@If "%TE_RECLISTROW2%"=="" Goto 2680
@Echo. SQLCMD -S %TE_DBSVR% -d %TE_DB% -w 120 -e -Q "UPDATE %TE_RECLIST% SET RecordDate = '%TE_RCDDATE%' WHERE TableName = '%TE_RECLISTROW2%'" >>%TE_OUT%
       SQLCMD -S %TE_DBSVR% -d %TE_DB% -w 120 -e -Q "UPDATE %TE_RECLIST% SET RecordDate = '%TE_RCDDATE%' WHERE TableName = '%TE_RECLISTROW2%'" | %TE_TEE%
:2680
@Echo. | %TE_TEE%
@If NOT "%TE_PAUSE%"=="" @Pause
@If "%TE_PAUSE%"=="" If Exist %TE_BASE%\SLEEP.EXE %TE_BASE%\SLEEP.EXE 1
@Echo. | %TE_TEE%


@Echo. | %TE_TEE%
@Echo.  Updating RecordCount in %TE_RECLIST% ... | %TE_TEE%
@Echo. SQLCMD -S %TE_DBSVR% -d %TE_DB% -w 120 -e -Q "UPDATE %TE_RECLIST% SET RecordCount = C.Cnt FROM (SELECT count(*) AS Cnt FROM %TE_TBL%) C WHERE TableName = '%TE_RECLISTROW%'" >>%TE_OUT%
       SQLCMD -S %TE_DBSVR% -d %TE_DB% -w 120 -e -Q "UPDATE %TE_RECLIST% SET RecordCount = C.Cnt FROM (SELECT count(*) AS Cnt FROM %TE_TBL%) C WHERE TableName = '%TE_RECLISTROW%'" | %TE_TEE%
@If "%TE_RECLISTROW2%"=="" Goto 2780
@Echo. SQLCMD -S %TE_DBSVR% -d %TE_DB% -w 120 -e -Q "UPDATE %TE_RECLIST% SET RecordCount = C.Cnt FROM (SELECT count(*) AS Cnt FROM %TE_TBL%) C WHERE TableName = '%TE_RECLISTROW2%'" >>%TE_OUT%
       SQLCMD -S %TE_DBSVR% -d %TE_DB% -w 120 -e -Q "UPDATE %TE_RECLIST% SET RecordCount = C.Cnt FROM (SELECT count(*) AS Cnt FROM %TE_TBL%) C WHERE TableName = '%TE_RECLISTROW2%'" | %TE_TEE%
:2780
@Echo. | %TE_TEE%
@If NOT "%TE_PAUSE%"=="" @Pause
@If "%TE_PAUSE%"=="" If Exist %TE_BASE%\SLEEP.EXE %TE_BASE%\SLEEP.EXE 1
@Echo. | %TE_TEE%


@Echo. | %TE_TEE%
@Echo.  Listing "TE_RECLISTROW% in %TE_RECLIST% ... | %TE_TEE%
@Echo. SQLCMD -S %TE_DBSVR% -d %TE_DB% -w 120 -e -Q "SELECT * FROM %TE_RECLIST% WHERE TableName = '%TE_RECLISTROW%'" >>%TE_OUT%
       SQLCMD -S %TE_DBSVR% -d %TE_DB% -w 120 -e -Q "SELECT * FROM %TE_RECLIST% WHERE TableName = '%TE_RECLISTROW%'" | %TE_TEE%
@If "%TE_RECLISTROW2%"=="" Goto 2880
@Echo. SQLCMD -S %TE_DBSVR% -d %TE_DB% -w 120 -e -Q "SELECT * FROM %TE_RECLIST% WHERE TableName = '%TE_RECLISTROW2%'" >>%TE_OUT%
       SQLCMD -S %TE_DBSVR% -d %TE_DB% -w 120 -e -Q "SELECT * FROM %TE_RECLIST% WHERE TableName = '%TE_RECLISTROW2%'" | %TE_TEE%
:2880
@Echo. | %TE_TEE%
@If NOT "%TE_PAUSE%"=="" @Pause
@If "%TE_PAUSE%"=="" If Exist %TE_BASE%\SLEEP.EXE %TE_BASE%\SLEEP.EXE 1
@Echo. | %TE_TEE%


@Echo. | %TE_TEE%
@Echo. Import processing is complete ... | %TE_TEE%
@If "%TE_PAUSE%"=="" If Exist %TE_BASE%\SLEEP.EXE %TE_BASE%\SLEEP.EXE 2
@Echo. | %TE_TEE%
@Goto END

:NO_FILE
@Echo. | %TE_TEE%
@Echo.  Unable to locate "%TE1%" | %TE_TEE%
@If NOT "%TE_PAUSE%"=="" @Pause
@If "%TE_PAUSE%"=="" If Exist %TE_BASE%\SLEEP.EXE %TE_BASE%\SLEEP.EXE 8
@Goto END

:SQL_ERR
@Echo. | %TE_TEE%
@Echo.  SQLCMD Error ... Process Ending | %TE_TEE%
@If NOT "%TE_PAUSE%"=="" @Pause
@If "%TE_PAUSE%"=="" If Exist %TE_BASE%\SLEEP.EXE %TE_BASE%\SLEEP.EXE 8
@Goto END


:END
@Echo. | %TE_TEE%
@Echo. IMPORT_VLTX ... %DATE% at %TIME% | %TE_TEE%
@Echo. -------------------- >> %TE_OUT%
@Set TE_CONFIG=
@Set TE_DBSVR=
@Set TE_DB=
@Set TE_VLTSRC=
@Set TE_VLTVER=
@Set TE_TBL=
@Set TE_RECLIST=
@Set TE_RECLISTROW=
@Set TE_RECLISTROW2=
@Set TE_OUT=
@Set TE_TMP=
@Set TE_RCDDATE=
@Set TE1=
@Set TableNameVLT=
@If NOT "%TE_PAUSE%"=="" @Pause
@If "%TE_PAUSE%"=="" If Exist %TE_BASE%\SLEEP.EXE %TE_BASE%\SLEEP.EXE 3
@Set TE_PAUSE=
@Set TE_BASE=
@Echo.
@ENDLOCAL
